<?php
// $Id: fetchgals_functions.inc,v 1.1.2.1 2008/02/25 09:50:38 pobster Exp $

/**
 * Creates and submits the find_galleries function
 */
function fetchgals_find_galleries() {
  if (fetchgals_process(variable_get('fetchgals_pid', 0))) {
    drupal_set_message(t('Another fetchgals process is currently running, please wait for it to finish'), 'error');
    return;
  }
  if (!file_exists(fetchgals_check(variable_get('fetchgals_tgp_file', './tgps')))) {
    drupal_set_message(t("'%gal' file is missing or not readable by the server", array('%gal' => variable_get('fetchgals_tgp_file', './tgps'))), 'error');
    return;
  }
  $dir = FG_CWD;
  if (!file_check_directory($dir, FALSE)) {
    drupal_set_message(t('Fetchgals directory is not writeable for the webserver. Please consult fetchgals/INSTALL.txt .'), 'error');
  }
  fetchgals_clear_log();
  $args = ' -find_galleries';
  $args .= ' -tgp_file '. fetchgals_check(variable_get('fetchgals_tgp_file', './tgps'));
  variable_get('fetchgals_extensive_search', 0) ? $args .= ' -extensive_search' : '';
  variable_get('fetchgals_extensive_search', 0) ? $args .= ' -attempts_per_link '. variable_get('fetchgals_attempts_per_link', 5) : '';
  variable_get('fetchgals_extensive_search', 0) ? $args .= ' -sleep_time '. variable_get('fetchgals_sleep_time', 7) : '';
  $args .= ' -gallery_file '. fetchgals_check(variable_get('fetchgals_gallery_file', './galleries'));
  variable_get('fetchgals_use_cookies', 0) ? $args .= ' -use_cookies' : '';
  fetchgals_write_log('\'Find Galleries\' process started: '. date(variable_get('date_format_long', 'l, F j, Y - H:i')) .'<br />perl '. FG_MAIN . $args .' >> '. FG_CWD .'log & echo $!');
  $fetchgals_pid = shell_exec('perl '. FG_MAIN . $args .' >> '. FG_CWD .'log & echo $!');
  if (!$fetchgals_pid) {
    drupal_set_message(t('Find Galleries Failed'), 'error');
  }
  else {
    drupal_set_message(t('Find Galleries function started'));
    variable_set('fetchgals_pid', $fetchgals_pid);
  }
  return;
} // fetchgals_find_galleries

/**
 * Creates and submits the download_pics function
 */
function fetchgals_download_pics() {
  if (fetchgals_process(variable_get('fetchgals_pid', 0))) {
    drupal_set_message(t('Another fetchgals process is currently running, please wait for it to finish'), 'error');
    return;
  }
  if (!file_exists(fetchgals_check(variable_get('fetchgals_gallery_file', './galleries')))) {
    drupal_set_message(t("'%gal' file is missing, please run 'Find Galleries' first", array('%gal' => variable_get('fetchgals_gallery_file', './galleries'))), 'error');
    return;
  }
  $dir = FG_CWD;
  if (!file_check_directory($dir, FALSE)) {
    drupal_set_message(t('Fetchgals directory is not writeable for the webserver. Please consult fetchgals/INSTALL.txt .'), 'error');
  }
  fetchgals_clear_log();
  $args = ' -download_pics';
  $args .= ' -gallery_file '. fetchgals_check(variable_get('fetchgals_gallery_file', './galleries'));
  $args .= ' -pics_dir '. fetchgals_check(variable_get('fetchgals_pics_dir', './porn_pics'));
  $args .= ' -processed_downloads_file '. fetchgals_check(variable_get('fetchgals_processed_downloads_file', './gals_downloaded'));
  $args .= ' -types "'. variable_get('fetchgals_types', 'jpg|jpeg|gif|png|mpg|mpeg|avi|asf|mov|wmv') .'"';
  $args .= ' -min_img_size '. variable_get('fetchgals_min_img_size', 15000);
  $args .= ' -max_img_size '. variable_get('fetchgals_max_img_size', 250000);
  $args .= ' -max_disk_usage '. variable_get('fetchgals_max_disk_usage', 95);
  $args .= ' -pic_file_template '. variable_get('fetchgals_pic_file_template', '%i/%h-%p-%n%e');
  $args .= ' -num_download_processes '. variable_get('fetchgals_num_download_processes', 8);
  $args .= ' -processed_html_file '. fetchgals_check(variable_get('fetchgals_processed_html_file', './gals_processed_html'));
  fetchgals_write_log('\'Download Pictures\' process started: '. date(variable_get('date_format_long', 'l, F j, Y - H:i')) .'<br />perl '. FG_MAIN . $args .' >> '. FG_CWD .'log & echo $!');
  $fetchgals_pid = shell_exec('perl '. FG_MAIN . $args .' >> '. FG_CWD .'log & echo $!');
  if (!$fetchgals_pid) {
    drupal_set_message(t('Download Pictures Failed'), 'error');
  }
  else {
    drupal_set_message(t('Download Pictures function started'));
    variable_set('fetchgals_pid', $fetchgals_pid);
  }
  return;
} // fetchgals_download_pics

/**
 * Creates and submits the create_html function
 */
function fetchgals_create_html() {
  if (fetchgals_process(variable_get('fetchgals_pid', 0))) {
    drupal_set_message(t('Another fetchgals process is currently running, please wait for it to finish'), 'error');
    return;
  }
  if (!file_exists(fetchgals_check(variable_get('fetchgals_gallery_file', './galleries')))) {
    drupal_set_message(t("'%gal' file is missing, please run 'Find Galleries' first", array('%gal' => variable_get('fetchgals_gallery_file', './galleries'))), 'error');
    return;
  }
  $dir = FG_CWD;
  if (!file_check_directory($dir, FALSE)) {
    drupal_set_message(t('Fetchgals directory is not writeable for the webserver. Please consult fetchgals/INSTALL.txt .'), 'error');
  }
  fetchgals_clear_log();
  $args = ' -create_html';
  $args .= ' -gallery_file '. fetchgals_check(variable_get('fetchgals_gallery_file', './galleries'));
  $args .= ' -html_dir '. fetchgals_check(variable_get('fetchgals_html_dir', './porn_html'));
  $args .= ' -thumbs_per_row '. variable_get('fetchgals_thumbs_per_row', 6);
  $args .= ' -rows_per_file '. variable_get('fetchgals_rows_per_file', 10);
  $args .= ' -processed_html_file '. fetchgals_check(variable_get('fetchgals_processed_html_file', './gals_processed_html'));
  fetchgals_write_log('\'Create HTML\' process started: '. date(variable_get('date_format_long', 'l, F j, Y - H:i')) .'<br />perl '. FG_MAIN . $args .' >> '. FG_CWD .'log & echo $!');
  $fetchgals_pid = shell_exec('perl '. FG_MAIN . $args .' >> '. FG_CWD .'log & echo $!');
  if (!$fetchgals_pid) {
    drupal_set_message(t('Create HTML Failed'), 'error');
  }
  else {
    drupal_set_message(t('Create HTML function started'));
    variable_set('fetchgals_pid', $fetchgals_pid);
  }
  return;
} // fetchgals_create_html

/**
 * Executes the findtgps program
 */
function fetchgals_findtgps() {
  if (fetchgals_process(variable_get('fetchgals_pid', 0))) {
    drupal_set_message(t('Another fetchgals process is currently running, please wait for it to finish'), 'error');
    return;
  }
  if (!file_exists(fetchgals_check(variable_get('findtgps_in', './tgps')))) {
    drupal_set_message(t("'%gal' file is missing or not readable by the server", array('%gal' => variable_get('findtgps_in', './tgps'))), 'error');
    return;
  }
  $dir = FG_CWD;
  if (!file_check_directory($dir, FALSE)) {
    drupal_set_message(t('Fetchgals directory is not writeable for the webserver. Please consult fetchgals/INSTALL.txt .'), 'error');
  }
  fetchgals_clear_log();
  $args = ' -in '. fetchgals_check(variable_get('findtgps_in', './tgps'));
  $args .= ' -out '. fetchgals_check(variable_get('findtgps_out', './tgps'));
  $args .= ' -known_tgps '. fetchgals_check(variable_get('findtgps_known_tgps', './tgps'));
  $args .= ' -link_threshold '. variable_get('findtgps_link_threshold', 30);
  $args .= ' -fraction_followed '. variable_get('findtgps_fraction_followed', 6);
  $args .= ' -threads '. variable_get('findtgps_threads', 8);
  fetchgals_write_log('\'Find TGPS\' process started: '. date(variable_get('date_format_long', 'l, F j, Y - H:i')) .'<br />perl '. FG_TGPS . $args .' >> '. FG_CWD .'log & echo $!');
  $fetchgals_pid = shell_exec('perl '. FG_TGPS . $args .' >> '. FG_CWD .'log & echo $!');
  if (!$fetchgals_pid) {
    drupal_set_message(t('FindTGPS Failed'), 'error');
  }
  else {
    drupal_set_message(t('FindTGPS function started'));
    variable_set('fetchgals_pid', $fetchgals_pid);
  }
  return;
} // fetchgals_findtgps
